-- ElvUI Companions Rewrite for 5.0.4 <Mounts LDB>
-- by Lockslap <adam at lockslap dot com>

-- Based on BrokerPets by Shackleford
local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local DT = E:GetModule("DataTexts")
local Frame = CreateFrame("Frame")
local menu = {}
local startChar = {
	["AB"] = {
	},
	["CD"] = {
	},
	["EF"] = {
	},
	["GH"] = {
	},
	["IJ"] = {
	},
	["KL"] = {
	},
	["MN"] = {
	},
	["OP"] = {
	},
	["QR"] = {
	},
	["ST"] = {
	},
	["UV"] = {
	},
	["WX"] = {
	},
	["YZ"] = {
	}
}
local defaults = {
	["id"]			= nil,
	["text"]		= nil,
	["icon"]		= nil,
	["favOne"]		= nil,
	["favTwo"]		= nil,
	["favThree"]	= nil,
}

local wipe		= table.wipe
local tinsert	= table.insert
local sort		= table.sort
local format	= string.format

local function OnClick(self, button)
	GameTooltip:Hide()
	if button == "RightButton" then
		ToggleDropDownMenu(1, nil, Frame, self, 0, 0)
	elseif button == "LeftButton" then
		if IsShiftKeyDown() then
			if mountdb.id ~= nil then
				CallCompanion("MOUNT", mountdb.id)
			end
		else
			TogglePetJournal()
		end
	end
end
local LDB = LibStub("LibDataBroker-1.1"):NewDataObject("MountsDT", {
	icon	= "Interface\\Icons\\ability_mount_quilenflyingmount",
	text	= "MountsDT",
	type	= "data source",
	OnClick	= OnClick,
})

function LDB.OnEnter(self)
	DT:SetupTooltip(self)
	GameTooltip:AddLine("|cff00ffffElvUI_Companions - Mounts Datatext|r")
	GameTooltip:AddLine("     <Left Click> to open Pet Journal.")
	GameTooltip:AddLine("     <Right Click> to open mount list.")
	GameTooltip:AddLine("     <Shift + Left Click> to summon last mount.")
	GameTooltip:AddLine("     <Left Click> a mount to summon it.")
	GameTooltip:AddLine("     <Right Click> a mount to pick it up.")
	GameTooltip:AddLine("     <ALT-Click> pet to set as favorite 1")
	GameTooltip:AddLine("     <CTRL-Click> pet to set as favorite 2")
	GameTooltip:AddLine("     <CTRL-ALT-Click> pet to set as favorite 3")
	if GetNumCompanions("MOUNT") == 0 then
		GameTooltip:AddLine("|cffff0000You have no mounts!|r")
	else
		GameTooltip:AddLine(("|cff00ff00You have %d mounts.|r"):format(GetNumCompanions("MOUNT")))
	end
end

local function pairsByKeys(startChar, f)
	local a = {}
	for n in pairs(startChar) do tinsert(a, n) end
	sort(a, f)
	local i = 0
	local iter = function()
		i = i + 1
		if a[i] == nil then
			return nil
		else
			return a[i], startChar[a[i]]
		end
	end
	return iter
end

local function GetCurrentMount()
	local numMounts = GetNumCompanions("MOUNT")
	if numMounts == 0 then return false, false, false end
	for i = 1, numMounts do
		local _, name, _, icon, active, _ = GetCompanionInfo("MOUNT", i)
		if active == 1 then return i, name, icon end
	end
	return false, false, false
end

local function UpdateDisplay()
	if mountdb.id ~= nil then
		LDB.text = mountdb.text
		LDB.icon = mountdb.icon
	end
	
	local curMount, name, icon = GetCurrentMount()
	if curMount ~= nil and name ~= nil and icon ~= nil and curMount ~= false and name ~= false and icon ~= false then
		LDB.text = ("|cff00ff00%s|r"):format(name)
		LDB.icon = icon
		mountdb.id = curMount
		mountdb.text = name
		mountdb.icon = icon
		return
	end
end

local function ModifiedClick(button, id)
	local _, name, _, _, _, _ = GetCompanionInfo("MOUNT", id)
	if not IsShiftKeyDown() and not IsControlKeyDown() and not IsAltKeyDown() then
		CallCompanion("MOUNT", id)
	elseif IsShiftKeyDown() and not IsControlKeyDown() and not IsAltKeyDown() then
		mountdb.favOne = id
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00ElvUI_Companions:|r %s added as favorite 1.", name))
	elseif not IsShiftKeyDown() and IsControlKeyDown() and not IsAltKeyDown() then
		mountdb.faveTwo = id
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00ElvUI_Companions:|r %s added as favorite 2.", name))
	elseif not IsShiftKeyDown() and not IsControlKeyDown() and IsAltKeyDown() then
		mountdb.favThree = id
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00ElvUI_Companions:|r %s added as favorite 3.", name))
	else
		PickupCompanion("MOUNT", id)
	end
end

local function CreateMenu(self, level)
	local numMounts = GetNumCompanions("MOUNT")
	menu = wipe(menu)
	
	if numMounts == 0 then return end
	if numMounts <= 20 then
		-- 20 mounts or less can use a single menu
		for i = 1, numMounts do
			local _, name, _, icon, active, _ = GetCompanionInfo("MOUNT", i)
			menu.hasArrow = false
			menu.notCheckable = true
			menu.text = name
			menu.icon = icon
			menu.colorCode = active == 1 and "|cff00ff00" or "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = i
			UIDropDownMenu_AddButton(menu)
		end
	else
		level = level or 1
		
		if level == 1 then
			for key, value in pairsByKeys(startChar) do
				menu.text = key
				menu.notCheckable = true
				menu.hasArrow = true
				menu.value = {
					["Level1_Key"] = key
				}
				UIDropDownMenu_AddButton(menu, level)
			end
			
					
			if mountdb.favOne ~= "" and mountdb.favOne ~= nil then
				local _, name, _, icon, active, _ = GetCompanionInfo("MOUNT", mountdb.favOne)
				menu.text = ("1. %s"):format(name)
				menu.icon = icon
				menu.colorCode = active == 1 and "|cff00ff00" or "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = mountdb.favOne
				menu.hasArrow = false
				menu.notCheckable = true
				UIDropDownMenu_AddButton(menu, level)
			end
			
			if mountdb.favTwo ~= "" and mountdb.favTwo ~= nil then
				local _, name, _, icon, active, _ = GetCompanionInfo("MOUNT", mountdb.favTwo)
				menu.text = ("1. %s"):format(name)
				menu.icon = icon
				menu.colorCode = active == 1 and "|cff00ff00" or "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = mountdb.favTwo
				menu.hasArrow = false
				menu.notCheckable = true
				UIDropDownMenu_AddButton(menu, level)
			end
			
			if mountdb.favThree ~= "" and mountdb.favThree ~= nil then
				local _, name, _, icon, active, _ = GetCompanionInfo("MOUNT", mountdb.favThree)
				menu.text = ("1. %s"):format(name)
				menu.icon = icon
				menu.colorCode = active == 1 and "|cff00ff00" or "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = mountdb.favThree
				menu.hasArrow = false
				menu.notCheckable = true
				UIDropDownMenu_AddButton(menu, level)
			end
		elseif level == 2 then
			local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"]
			
			for i = 1, numMounts do
				local _, name, _, icon, active, _ = GetCompanionInfo("MOUNT", i)
				local firstChar = name:sub(1, 1):upper()
				menu.hasArrow = false
				menu.notCheckable = true
				menu.text = name
				menu.icon = icon
				menu.colorCode = active == 1 and "|cff00ff00" or "|cffffffff"
				menu.func = ModifiedClick
				menu.arg1 = i
				
				if firstChar >= "A" and firstChar <= "B" and Level1_Key == "AB" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "C" and firstChar <= "D" and Level1_Key == "CD" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "E" and firstChar <= "F" and Level1_Key == "EF" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "G" and firstChar <= "H" and Level1_Key == "GH" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "I" and firstChar <= "J" and Level1_Key == "IJ" then
					UIDropDownMenu_AddButton(menu, level)
				end
			
				if firstChar >= "K" and firstChar <= "L" and Level1_Key == "KL" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "M" and firstChar <= "N" and Level1_Key == "MN" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "O" and firstChar <= "P" and Level1_Key == "OP" then
					UIDropDownMenu_AddButton(menu, level)
				end
			
				if firstChar >= "Q" and firstChar <= "R" and Level1_Key == "QR" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "S" and firstChar <= "T" and Level1_Key == "ST" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "U" and firstChar <= "V" and Level1_Key == "UV" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "W" and firstChar <= "X" and Level1_Key == "WX" then
					UIDropDownMenu_AddButton(menu, level)
				end
				
				if firstChar >= "Y" and firstChar <= "Z" and Level1_Key == "YZ" then
					UIDropDownMenu_AddButton(menu, level)
				end
			end
		end
	end
end

function Frame:PLAYER_LOGIN()
	mountdb = mountdb or {}
	for index, value in pairs(defaults) do
		if type(mountdb[index]) == "nil" then
			mountdb[index] = value
		end
	end
	
	self:RegisterEvent("COMPANION_UPDATE")
	self.COMPANION_UPDATE = UpdateDisplay
	
	self:RegisterEvent("PET_JOURNAL_LIST_UPDATE")
	self.PET_JOURNAL_LIST_UPDATE = UpdateDisplay
	
	self.initialize = CreateMenu
	self.displayMode = "MENU"
	
	UpdateDisplay()
end

Frame:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)
Frame:RegisterEvent("PLAYER_LOGIN")